//------------------------------------------------------------------------------
// Name:        wdt400br.js
//
// Description: script for field validation
//
//------------------------------------------------------------------------------
var msg = new Array();
//
// Only these message strings require translation
msg[1] = " - Invalid characters in numeric field";
msg[2] = " - Use of decimals incorrect";
msg[3] = " - Use of minus sign character incorrect";
msg[4] = " - Too many numbers entered";
msg[5] = " - Exceed maximum field length";
msg[6] = "Submission aborted due to invalid data detected in field - ";
msg[7] = " - Use of plus sign character incorrect";
//
//

var ValFailedArray = new Array();
var iCnt = 0;
var msgInvalid = "";
//
// goSetInvalid
function goSetInvalid( field, status )
{
	if( status )
	{
		var bFound = false;
		alert(field.name + msgInvalid);
		for( i=0; i<ValFailedArray.length; i++ )
		{
			if( ValFailedArray[i] == field.name )
			{
				bFound = true;
				break;
			}
		}
		// add to invalid array if error detected for the 1st time
		if( !bFound )
			ValFailedArray[iCnt++] = field.name;
	}
	else
	{
		// field is good now, clear invalid entry in array
		for( i=0; i<ValFailedArray.length; i++ )
		{
			if( ValFailedArray[i] == field.name )
			{
				//ValFailedArray.splice(i,1);
				var tempArray = new Array();
				ValFailedArray = tempArray.concat( ValFailedArray.slice(0,i),  ValFailedArray.slice(i+1) );
				iCnt--;
				break;
			}
		}
	}		
}
//
// goCheckStr
function goCheckStr( field, length )
{
	if( field.value.length > length )
	{
		msgInvalid = msg[5];
		goSetInvalid( field, true );
	}
	else
	{
		goSetInvalid( field, false );
	}
}
//
// goCheckNum
function goCheckNum( e, length, dPos, cMinus, cDec )
{
	var allow = "0123456789+" + cDec + cMinus;
	//allow = allow + decsep;
	var val = e.value;
	var pos = dPos;
	var len = length;
	var rc = 0;
	var minusfound = false;
	var decfound = false;
	var dec = 0;
	var bval = "";
	for(var j = 0; j <= val.length; j++)
	{
		c = val.substr(j, 1);
		if( allow.indexOf( c ) == -1)
		{
			rc = 1;
			break;
		}
	}
	if( rc == 0 )
	{
		for( var j = 0; j <= val.length; j++)
		{
			c = val.charAt(j);
			if( c >=0 || c<=9 || c == cDec || c == cMinus || c == '+' )
			{
				if( c == cDec && decfound == true)
				{
					rc = 2;
					break;
				}
				if( c == cMinus && j!= 0 )
				{
					rc = 3;
					break;
				}
				if( c == '+' && j!= 0 )
				{
					rc = 7;
					break;
				}
				if( c == cDec )
					decfound = true;

				// only filter numeric and decimal
				if( (c != cMinus) && (c != '+') )
					bval += c;
			}
		}

		// have decimal position
		if( pos != 0 )
		{
			dec = bval.indexOf(cDec);
			// decimal char exist
			if( dec != -1 )	
			{
				// check decimal length
				if( (bval.length - dec - 1) > pos )
					rc = 2;
				// check numeric len before decimal
				if( dec > (len - pos) )
					rc = 4;
			}
			else
			{
				if( bval.length > (len - pos) )
					rc = 4;
			}
		}
		else
		{
			dec = bval.indexOf(cDec);
			// decimal char exist
			if( dec != -1 )	
				rc = 2;
			else if( (bval.length) > len )
				rc = 4;
		}
	}
	if( rc != 0 )
	{
		msgInvalid = msg[rc];
		goSetInvalid( e, true );
	}
	else
	{
		goSetInvalid( e, false );
	}
}
//
// isSubmitOK
function  isSubmitOK()
{
	if( ValFailedArray.length != 0 )
	{
		// promte user which field is invalid 
		var fields = "";
		for( i=0; i<ValFailedArray.length; i++ )
		{
			fields += ValFailedArray[i] + " ";
		}
		alert( msg[6] + fields );
		return false;
	}
	else
	{
		return true;
	}
}
